2018-01-30 16:00:11 +00:00
#!/bin/bash
# (1) Init.
#--------------------------------------------------------#
# (1) Get current absolute dir
ROOT=$(dirname `realpath $0`);
# (2) Check argc
2018-01-31 23:21:34 +00:00
test $# -lt 3 && echo -e "error: too fewarguments\n\n\e[1mUSAGE\e[0m\n\tbind-output <id> <ip> <port>\n\n\e[1mARGUMENTS\e[0m\n\t<id>\tThe identifier of the output (buffer name)\n\t<ip>\tThe ip or host of the target\n\t<port>\tThe port to connect to\n" && exit 1;
2018-01-30 16:00:11 +00:00
# (3) Check @PORT range #
2018-01-30 17:49:37 +00:00
MIN_PORT=1024;
MAX_PORT=49151;
2018-01-30 16:00:11 +00:00
test "$3" -gt "$MAX_PORT" -o "$3" -lt "$MIN_PORT" && echo "error: <port> must be between $MIN_PORT and $MAX_PORT" && exit 1;
# (4) Set argument explicit names #
OUT_ID="$1";
OUT_IP="$2";
OUT_PT="$3";
2018-01-31 23:21:34 +00:00
# (5) Manage optional 'silent' argument #
DEBUG="";
test $# -ge 4 -a "$4" == "debug" && DEBUG="xx";
2018-01-30 16:00:11 +00:00
# (2) Prepare buffer
#--------------------------------------------------------#
# (1) Create buffer path
BUFFER="/tmp/outbuf_$OUT_ID";
# (2) Create/Flush buffer
2018-01-31 23:21:34 +00:00
# test -f $BUFFER && rm $BUFFER;
echo -n "" > $BUFFER;
2018-01-30 16:00:11 +00:00
2018-01-31 23:28:32 +00:00
# (3) Remove buffer + kill loop #
on_exit(){
[[ $DEBUG ]] && echo " < closing binding from $BUFFER to $OUT_IP:$OUT_PT";
rm $BUFFER 2>/dev/null && ( [[ $DEBUG ]] && echo " < $BUFFER deleted" );
kill -INT $LOOP_PID 2>/dev/null;
exit 1;
}
2018-01-30 16:00:11 +00:00
2018-01-30 21:54:17 +00:00
# (3) Launch OUTPUT server
2018-01-30 16:00:11 +00:00
#--------------------------------------------------------#
(
2018-01-31 23:21:34 +00:00
[[ $DEBUG ]] && echo " > binding $BUFFER to $OUT_IP:$OUT_PT";
2018-01-31 23:28:32 +00:00
trap "kill -9 $NC_PID 2>/dev/null; on_exit;" HUP INT KILL TERM;
2018-01-30 16:00:11 +00:00
outfail=0;
# (1) kill script after 10 failures
2018-01-30 18:37:00 +00:00
while [ $outfail -lt 10 ]; do
2018-01-30 16:00:11 +00:00
2018-01-30 18:37:00 +00:00
# (3) Check if port open
2018-01-30 21:54:17 +00:00
nc -z $OUT_IP $OUT_PT >/dev/null 2>&1;
2018-01-30 18:37:00 +00:00
PORT_CLOSED=$?;
# (4) Manage taken port #
if [ "$PORT_CLOSED" -eq "1" ]; then
outfail="`expr $outfail + 1`";
2018-01-30 21:54:17 +00:00
test "$outfail" -gt "1" && sleep .5;
2018-01-30 18:37:00 +00:00
continue;
fi;
# (5) Bind output
outfail="0";
2018-01-31 19:54:16 +00:00
tail -f $BUFFER | nc $OUT_IP $OUT_PT 2> /dev/null &
NC_PID=$!;
wait $NC_PID;
2018-01-30 16:00:11 +00:00
done;
)&
LOOP_PID=$!;
2018-01-31 19:54:16 +00:00
trap "on_exit;" HUP INT KILL TERM;
2018-01-30 21:54:17 +00:00
2018-01-31 23:28:32 +00:00
echo -n "$LOOP_PID";